Ruby: include/ruby/internal/intern/select.h File Reference

Ruby 3.0.5p211 (2022-11-24 revision ba5cf0f7c52d4d35cc6a173c89eda98ceffa2dcf)

Macros | Functions
select.h File Reference

Public APIs to provide rb_fd_select(). More...

`#include "ruby/internal/config.h"`
`#include "ruby/internal/dllexport.h"`
`#include "ruby/internal/intern/select/posix.h"`

Go to the source code of this file.

## Macros
#define | rb_fd_resize(n, f) ((void)(f))

## Functions
int | rb_thread_fd_select (int, rb_fdset_t *, rb_fdset_t *, rb_fdset_t *, struct timeval *)

## Detailed Description

Public APIs to provide rb_fd_select().

Author
  Ruby developers ruby-.nosp@m.core.nosp@m.@ruby.nosp@m.-lan.nosp@m.g.org

Copyright
  This file is a part of the programming language Ruby. Permission is hereby granted, to either redistribute and/or modify this file, provided that the conditions mentioned in the file COPYING are met. Consult the file for details.

Warning
  Symbols prefixed with either `RBIMPL` or `rbimpl` are implementation details. Don't take them as canon. They could rapidly appear then vanish. The name (path) of this header file is also an implementation detail. Do not expect it to persist at the place it is now. Developers are free to move it anywhere anytime at will.

Note
  To ruby-core: remember that this header can be possibly recursively included from extension libraries written in C++. Do not expect for instance `__VA_ARGS__` is always available. We assume C99 for ruby itself but we don't assume languages of extension libraries. They could be written in C++98.
  Functions and structs defined in this header file are not necessarily ruby-specific. They don't need VALUE etc.

Definition in file select.h.

## Macro Definition Documentation

## ◆ rb_fd_resize

#define rb_fd_resize | ( |  | n,
|  |  | f
| ) |  | ((void)(f))

Definition at line 41 of file select.h.

## Function Documentation

## ◆ rb_thread_fd_select()

int rb_thread_fd_select | ( | int | max,
|  | rb_fdset_t * | read,
|  | rb_fdset_t * | write,
|  | rb_fdset_t * | except,
|  | struct timeval * | timeout
| ) |  |

Definition at line 4330 of file thread.c.

References rb_thread_struct::ec, select_set::eset, fd_init_copy, max, select_set::max, select_set::orig_rset, rb_ensure(), rb_fd_set, rb_sigwait_fd_get(), rb_thread_sleep_forever(), rb_thread_wait_for(), read(), select_set::rset, RUBY_VM_CHECK_INTS_BLOCKING, select_set::sigwait_fd, select_set::th, select_set::timeout, write(), and select_set::wset.